/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.staat.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.staat.entity.Staat;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractStaatSearch {

  @Inject
  protected transient StaatExtendedDAO dao;

  public AbstractStaatSearch() {
    super();
  }

  public List<Staat> getSearchResult(StaatSearchParameters searchParameters, EagerLoadingCollector<Staat> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<Staat> querySearchResult(StaatSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
